## cl-asdf 2.21

=== Makefile ===
system	 	:= "asdf"
webhome_private := common-lisp.net:/project/asdf/public_html/
webhome_public	:= "http://common-lisp.net/project/asdf/"
clnet_home      := "/project/asdf/public_html/"
sourceDirectory := $(shell pwd)

ifdef ASDF_TEST_LISPS
lisps ?= ${ASDF_TEST_LISPS}
else
lisps ?= ccl clisp sbcl ecl cmucl abcl scl allegro lispworks
endif

## MINOR FAIL: ecl-bytecodes (failure in test-compile-file-failure.script)
## MINOR FAIL: xcl (logical pathname issue in asdf-pathname-test.script)
## OCCASIONALLY TESTED BY NOT ME: allegromodern (not in my free demo version)
## MAJOR FAIL: gclcvs -- COMPILER BUG! Upstream fixed it, but upstream fails to compile.
## NOT SUPPORTED BY OUR TESTS: cormancl genera rmcl. Manually tested once in a while.

lisp ?= sbcl

CCL ?= ccl
CLISP ?= clisp
SBCL ?= sbcl
ECL ?= ecl
CMUCL ?= cmucl
ABCL ?= abcl
SCL ?= scl
ALLEGRO ?= alisp
ALLEGROMODERN ?= mlisp
LISPWORKS ?= lispworks

# website, tag, install

default: test

install: archive-copy

archive:
	${SBCL} --userinit /dev/null --sysinit /dev/null --load bin/make-helper.lisp \
		--eval "(rewrite-license)" --eval "(quit)"
	bin/make-tarball

archive-copy: archive
	git checkout release
	bin/rsync-cp tmp/asdf*.tar.gz $(webhome_private)/archives
	bin/link-tarball $(clnet_home)
	bin/rsync-cp tmp/asdf.lisp $(webhome_private)
	${MAKE} push
	git checkout master

push:
	git status
	git push --tags cl.net release master
	git fetch
	git status

doc:
	${MAKE} -C doc

website:
	${MAKE} -C doc website

clean_dirs = $(sourceDirectory)
clean_extensions = fasl dfsl cfsl fasl fas lib dx32fsl lx64fsl lx32fsl ufasl o bak x86f vbin amd64f sparcf sparc64f hpf hp64f

clean:
	@for dir in $(clean_dirs); do \
	     if test -d $$dir; then \
	     	 echo Cleaning $$dir; \
		 for ext in $(clean_extensions); do \
		     find $$dir \( -name "*.$$ext" \) \
	     	    -and -not -path \""*/.git/*"\" \
		     	  -and -not -path \""*/_darcs/*"\" \
	     		  -and -not -path \""*/tags/*"\" -print -delete; \
		done; \
	     fi; \
	done
	rm -rf tmp/ LICENSE test/try-reloading-dependency.asd
	${MAKE} -C doc clean

mrproper: clean
	rm -rf .pc/ build-stamp debian/patches/ debian/debhelper.log debian/cl-asdf/ # debian crap

test-upgrade:
	fasl=fasl ; \
	use_ccl () { li="${CCL} --no-init --quiet" ; ev="--eval" ; fasl=lx86fsl ; } ; \
	use_clisp () { li="${CLISP} -norc -ansi --quiet --quiet" ; ev="-x" ; fasl=fas ; } ; \
	use_sbcl () { li="${SBCL} --noinform --no-userinit" ; ev="--eval" ; fasl=fasl ; } ; \
	use_ecl () { li="${ECL} -norc" ; ev="-eval" ; fasl=fas ; } ; \
	use_cmucl () { li="${CMUCL} -noinit" ; ev="-eval" ; fasl=sse2f ; } ; \
	use_abcl () { li="${ABCL} --noinit --nosystem --noinform" ; ev="--eval" ; fasl=fasl ; } ; \
	use_scl () { li="${SCL} -noinit" ; ev="-eval" ; fasl=sse2f ; } ; \
	use_allegro () { li="${ALLEGRO} -q" ; ev="-e" ; fasl=fas ; } ; \
	use_allegromodern () { li="${ALLEGROMODERN} -q" ; ev="-e" ; fasl=fas ; } ; \
	use_lispworks () { li="${LISPWORKS} -siteinit - -init -" ; ev="-eval" ; fasl=ufasl ; } ; \
	use_${lisp} ; \
	mkdir -p tmp/fasls/${lisp} ; \
	fa=tmp/fasls/${lisp}/upasdf.$${fasl} ; \
	ll="(handler-bind (#+sbcl (sb-kernel:redefinition-warning #'muffle-warning)) (format t \"ll~%\") (load \"asdf.lisp\"))" ; \
	cf="(handler-bind ((warning #'muffle-warning)) (format t \"cf~%\") (compile-file \"asdf.lisp\" :output-file \"$$fa\" :verbose t :print t))" ; \
	lf="(handler-bind (#+sbcl (sb-kernel:redefinition-warning #'muffle-warning)) (format t \"lf\") (load \"$$fa\" :verbose t :print t))" ; \
	la="(handler-bind (#+sbcl (sb-kernel:redefinition-warning #'muffle-warning)) (format t \"la\") (push #p\"${sourceDirectory}/\" asdf:*central-registry*) (asdf:oos 'asdf:load-op :asdf :verbose t))" ; \
	te="(asdf-test::quit-on-error $$l (push #p\"${sourceDirectory}/test/\" asdf:*central-registry*) (princ \"te\") (asdf:oos 'asdf:load-op :test-module-depend :verbose t))" ; \
	su=test/script-support ; lu="(load\"$$su\")" ; \
	lv="$$li $$ev $$lu $$ev" ; \
	for tag in 1.37 1.97 1.369 `git tag -l '2.0??'` `git tag -l '2.??'` ; do \
	  rm -f $$fa ; \
	  for x in load-system load-lisp load-lisp-compile-load-fasl load-fasl just-load-fasl ; do \
	    lo="(handler-bind ((warning #'muffle-warning)) (load \"tmp/asdf-$${tag}.lisp\"))" ; \
	    echo "Testing upgrade from ASDF $${tag} using method $$x" ; \
	    git show $${tag}:asdf.lisp > tmp/asdf-$${tag}.lisp ; \
	    case ${lisp}:$$tag:$$x in \
	      ecl:1.*|ecl:2.00*|ecl:2.01[0-6]:*|ecl:2.20:*) \
		: Skip, because of various ASDF issues ;; \
	      cmucl:1.*) \
		: Skip, CMUCL cannot upgrade from ASDF 1. Happily, it ships ASDF 2 ;; \
	      *) (set -x ; \
                  case $$x in \
		    load-system) $$lv "$$lo" $$ev "$$la" $$ev "$$te" ;; \
		    load-lisp) $$lv "$$lo" $$ev "$$ll" $$ev "$$te" ;; \
		    load-lisp-compile-load-fasl) $$lv "$$lo" $$ev "$$ll" $$ev "$$cf" $$ev "$$lf" $$ev "$$te" ;; \
		    load-fasl) $$lv "$$lo" $$ev "$$lf" $$ev "$$te" ;; \
		    just-load-fasl) $$lv "$$lf" $$ev "$$te" ;; \
		    *) echo "WTF?" ; exit 2 ;; esac ) || \
		{ echo "upgrade FAILED" ; exit 1 ;} ;; esac ; \
	done ; done

test-forward-references:
	${SBCL} --noinform --no-userinit --no-sysinit --load asdf.lisp --eval '(sb-ext:quit)' 2>&1 | cmp - /dev/null

test-lisp:
	@cd test; ${MAKE} clean;./run-tests.sh ${lisp} ${test-glob}

test: test-lisp test-forward-references doc

test-all-lisps:
	@for lisp in ${lisps} ; do \
		${MAKE} test-lisp test-upgrade lisp=$$lisp || exit 1 ; \
	done

# test upgrade is a very long run... This does just the regression tests
test-all-noupgrade:
	@for lisp in ${lisps} ; do \
		${MAKE} test-lisp lisp=$$lisp || exit 1 ; \
	done

test-all-upgrade:
	@for lisp in ${lisps} ; do \
		${MAKE} test-upgrade lisp=$$lisp || exit 1 ; \
	done


test-all: test-forward-references doc test-all-lisps

# Note that the debian git at git://git.debian.org/git/pkg-common-lisp/cl-asdf.git is stale,
# as we currently build directly from upstream at git://common-lisp.net/projects/asdf/asdf.git
debian-package: mrproper
	: $${RELEASE:="$$(git tag -l '2.[0-9][0-9]' | tail -n 1)"} ; \
	git-buildpackage --git-debian-branch=release --git-upstream-branch=$$RELEASE --git-tag --git-retag --git-ignore-branch

# Replace SBCL's ASDF with the current one. -- Not recommended now that SBCL has ASDF2.
# for casual users, just use (asdf:load-system :asdf)
replace-sbcl-asdf:
	${SBCL} --eval '(compile-file "asdf.lisp" :output-file (format nil "~Aasdf/asdf.fasl" (sb-int:sbcl-homedir-pathname)))' --eval '(quit)'

# Replace CCL's ASDF with the current one. -- Not recommended now that CCL has ASDF2.
# for casual users, just use (asdf:load-system :asdf)
replace-ccl-asdf:
	${CCL} --eval '(progn(compile-file "asdf.lisp" :output-file (compile-file-pathname (format nil "~Atools/asdf.lisp" (ccl::ccl-directory))))(quit))'

WRONGFUL_TAGS := 1.37 1.1720 README RELEASE STABLE
# Delete wrongful tags from local repository
fix-local-git-tags:
	for i in ${WRONGFUL_TAGS} ; do git tag -d $$i ; done

# Delete wrongful tags from remote repository
fix-remote-git-tags:
	for i in ${WRONGFUL_TAGS} ; do git push $${REMOTE:-cl.net} :refs/tags/$$i ; done

release-push:
	git checkout master
	git merge release
	git checkout release
	git merge master
	git checkout master

TODO:
	exit 2

release: TODO test-all test-on-other-machines-too debian-changelog debian-package send-mail-to-mailing-lists

.PHONY: install archive archive-copy push doc website clean mrproper \
	upgrade-test test-forward-references test test-lisp test-upgrade test-forward-references \
	test-all test-all-lisps test-all-noupgrade \
	debian-package release \
	replace-sbcl-asdf replace-ccl-asdf \
	fix-local-git-tags fix-remote-git-tags

=== debian/changelog ===
cl-asdf (2:2.21-1) unstable; urgency=low

  * New features:
    * Most importantly, encodings.
      ASDF now lets you specify an :encoding for a system, module or component,
      that is used when loading or compiling Lisp files. See the documentation.
      By default, the only useful value is :utf-8, and
      we recommend you use UTF-8 everywhere.
      We intend to make UTF-8 the default in the future
      (current default is the legacy behavior of using whichever implicit
      default your underlying implementation is currently configured to use).
      An extension asdf-encodings is available that supports more encodings,
      including autodetection of encoding from either emacs-style declaration
      -*- Mode: Lisp ; coding: utf-8 -*- or content.
    * require-system works like load-system, but won't try to load or update
      systems that have already been loaded, as listed by loaded-systems.
      More generally, you can specify a list of systems as :force-not argument
      to load-system and the specified systems won't be loaded or updated.
    * You can specify :force-not and a list of systems when loading a system,
    * You can now specify :hostname in your asdf-output-translations,
      so you can easily share a home directory via the network
      yet split its fasl cache between several subtly different machines.
  * Bug Fixes:
    * lp#982285. since 2.014.4, the default source-registry
      was skipping anything from /usr or XDG_DATA_DIRS,
      because of a missing test in getenv-absolute-pathnames. Fixed in .15.
    * In 2.019.9 aka 2.20, ECL support was broken by using
      a function in the wrong package (defined in cl-user). Fixed in .1.
    * logical-pathname support was somewhat broken since 2.017.6,
      due to the way most implementations fail to read physical namestrings
      when *default-pathname-defaults* is a logical-pathname.
      Fixed, together with other logical-pathname issues,
      and a test case was added to the test suite to ensure no further regression.
      Works great modulo quirks around implementation bugs on CLISP and Allegro.
    * Make upgrading ASDF more robust on CMUCL, LispWorks, SBCL.
  * Minor tweaks:
    * Use :unspecific in pathname components on more implementations.
    * export and/or document more utilities.
    * add a few missing compatfmt for Genera.

 -- Francois-Rene Rideau <fare@tunes.org>  Sat, 28 Apr 2012 23:55:23 -0400

## cl-asdf 2.22

=== Makefile ===
--- 
+++ 
@@ -83,24 +83,17 @@
 
 test-upgrade:
 	fasl=fasl ; \
-	use_ccl () { li="${CCL} --no-init --quiet" ; ev="--eval" ; fasl=lx86fsl ; } ; \
-	use_clisp () { li="${CLISP} -norc -ansi --quiet --quiet" ; ev="-x" ; fasl=fas ; } ; \
-	use_sbcl () { li="${SBCL} --noinform --no-userinit" ; ev="--eval" ; fasl=fasl ; } ; \
-	use_ecl () { li="${ECL} -norc" ; ev="-eval" ; fasl=fas ; } ; \
-	use_cmucl () { li="${CMUCL} -noinit" ; ev="-eval" ; fasl=sse2f ; } ; \
-	use_abcl () { li="${ABCL} --noinit --nosystem --noinform" ; ev="--eval" ; fasl=fasl ; } ; \
-	use_scl () { li="${SCL} -noinit" ; ev="-eval" ; fasl=sse2f ; } ; \
-	use_allegro () { li="${ALLEGRO} -q" ; ev="-e" ; fasl=fas ; } ; \
-	use_allegromodern () { li="${ALLEGROMODERN} -q" ; ev="-e" ; fasl=fas ; } ; \
-	use_lispworks () { li="${LISPWORKS} -siteinit - -init -" ; ev="-eval" ; fasl=ufasl ; } ; \
+	use_ccl () { li="${CCL} --no-init --quiet" ; ev="--eval" ; } ; \
+	use_clisp () { li="${CLISP} -norc -ansi --quiet --quiet" ; ev="-x" ; } ; \
+	use_sbcl () { li="${SBCL} --noinform --no-userinit" ; ev="--eval" ; } ; \
+	use_ecl () { li="${ECL} -norc" ; ev="-eval" ; } ; \
+	use_cmucl () { li="${CMUCL} -noinit" ; ev="-eval" ; } ; \
+	use_abcl () { li="${ABCL} --noinit --nosystem --noinform" ; ev="--eval" ; } ; \
+	use_scl () { li="${SCL} -noinit" ; ev="-eval" ; } ; \
+	use_allegro () { li="${ALLEGRO} -q" ; ev="-e" ; } ; \
+	use_allegromodern () { li="${ALLEGROMODERN} -q" ; ev="-e" ; } ; \
+	use_lispworks () { li="${LISPWORKS} -siteinit - -init -" ; ev="-eval" ; } ; \
 	use_${lisp} ; \
-	mkdir -p tmp/fasls/${lisp} ; \
-	fa=tmp/fasls/${lisp}/upasdf.$${fasl} ; \
-	ll="(handler-bind (#+sbcl (sb-kernel:redefinition-warning #'muffle-warning)) (format t \"ll~%\") (load \"asdf.lisp\"))" ; \
-	cf="(handler-bind ((warning #'muffle-warning)) (format t \"cf~%\") (compile-file \"asdf.lisp\" :output-file \"$$fa\" :verbose t :print t))" ; \
-	lf="(handler-bind (#+sbcl (sb-kernel:redefinition-warning #'muffle-warning)) (format t \"lf\") (load \"$$fa\" :verbose t :print t))" ; \
-	la="(handler-bind (#+sbcl (sb-kernel:redefinition-warning #'muffle-warning)) (format t \"la\") (push #p\"${sourceDirectory}/\" asdf:*central-registry*) (asdf:oos 'asdf:load-op :asdf :verbose t))" ; \
-	te="(asdf-test::quit-on-error $$l (push #p\"${sourceDirectory}/test/\" asdf:*central-registry*) (princ \"te\") (asdf:oos 'asdf:load-op :test-module-depend :verbose t))" ; \
 	su=test/script-support ; lu="(load\"$$su\")" ; \
 	lv="$$li $$ev $$lu $$ev" ; \
 	for tag in 1.37 1.97 1.369 `git tag -l '2.0??'` `git tag -l '2.??'` ; do \
@@ -112,21 +105,24 @@
 	    case ${lisp}:$$tag:$$x in \
 	      ecl:1.*|ecl:2.00*|ecl:2.01[0-6]:*|ecl:2.20:*) \
 		: Skip, because of various ASDF issues ;; \
-	      cmucl:1.*) \
-		: Skip, CMUCL cannot upgrade from ASDF 1. Happily, it ships ASDF 2 ;; \
+	      ccl:1.*|ccl:2.0[01]*) \
+		: Skip, because ccl broke old asdf ;; \
+	      cmucl:1.*|cmucl:2.00*|cmucl:2.01[0-4]:*) \
+		: Skip, CMUCL has problems before 2.014.7 due to source-registry upgrade ;; \
 	      *) (set -x ; \
                   case $$x in \
-		    load-system) $$lv "$$lo" $$ev "$$la" $$ev "$$te" ;; \
-		    load-lisp) $$lv "$$lo" $$ev "$$ll" $$ev "$$te" ;; \
-		    load-lisp-compile-load-fasl) $$lv "$$lo" $$ev "$$ll" $$ev "$$cf" $$ev "$$lf" $$ev "$$te" ;; \
-		    load-fasl) $$lv "$$lo" $$ev "$$lf" $$ev "$$te" ;; \
-		    just-load-fasl) $$lv "$$lf" $$ev "$$te" ;; \
-		    *) echo "WTF?" ; exit 2 ;; esac ) || \
+		    load-system) l="$$lo (asdf-test::load-asdf-system)" ;; \
+		    load-lisp) l="$$lo (asdf-test::load-asdf-lisp)" ;; \
+		    load-lisp-compile-load-fasl) l="$$lo (asdf-test::compile-load-asdf)" ;; \
+		    load-fasl) l="$$lo (asdf-test::load-asdf-fasl)" ;; \
+		    just-load-fasl) l="(asdf-test::load-asdf-fasl)" ;; \
+		    *) echo "WTF?" ; exit 2 ;; esac ; \
+		  $$lv "(asdf-test::test-asdf $$l)" ) || \
 		{ echo "upgrade FAILED" ; exit 1 ;} ;; esac ; \
 	done ; done
 
 test-forward-references:
-	${SBCL} --noinform --no-userinit --no-sysinit --load asdf.lisp --eval '(sb-ext:quit)' 2>&1 | cmp - /dev/null
+	${SBCL} --noinform --no-userinit --no-sysinit --load asdf.lisp --load test/script-support.lisp --eval '(asdf-test::exit-lisp 0)' 2>&1 | cmp - /dev/null
 
 test-lisp:
 	@cd test; ${MAKE} clean;./run-tests.sh ${lisp} ${test-glob}

=== debian/changelog ===
cl-asdf (2:2.22-1) unstable; urgency=low

  * require is now mapped to the recently defined require-system,
   not to load-system anymore.
  * more sensible inheritance semantics for default-component-class,
   which can be either a class or a class name.
  * accept wildcards in directory-files for physical pathnames. lp#1000842

 -- Francois-Rene Rideau <fare@tunes.org>  Tue, 12 Jun 2012 11:22:33 -0400

=== debian/control ===
Source: cl-asdf
Section: lisp
Priority: optional
Maintainer: Debian Common Lisp Team <pkg-common-lisp-devel@lists.alioth.debian.org>
Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
  Milan Zamazal <pdm@zamazal.org>,
  Francois-Rene Rideau <fare@tunes.org>
Build-Depends: debhelper (>> 7)
Build-Depends-Indep: texinfo, texlive-extra-utils, texlive, texlive-generic-recommended
Standards-Version: 3.9.3
Homepage: http://common-lisp.net/project/asdf/
Vcs-Git: git://common-lisp.net/projects/asdf/asdf.git

Package: cl-asdf
Architecture: all
Recommends: common-lisp-controller, sbcl | lisp-compiler
Replaces: sbcl-common (<= 1:0.9.13.0-2)
Conflicts: sbcl-common (<= 1:0.9.13.0-2), common-lisp-controller (<< 7.3)
Breaks: common-lisp-controller (<< 7.3)
Depends: ${misc:Depends}
Description: Another System Definition Facility
 asdf provides a "make" type functions for Common Lisp software.
 It drives compilation and dynamic loading for complex Lisp systems
 with multiple modules and files, and is the de facto standard used
 by free software written in Common Lisp.

=== debian/rules ===
#!/usr/bin/make -f
# MAde with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir
	make -C doc all
	touch build-stamp

build-arch:
build-indep: build

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	make -C doc veryclean
	dh_clean

# Build architecture-dependent files here.
binary-arch: build
# We have nothing to do by default.

# Build architecture-independent files here.
binary-indep: build
	dh_testdir -i
	dh_testroot -i
	dh_prep -i
	chmod +x test/run-tests.sh
	dh_installdirs -i
	dh_install -i
	#dh_lisp -i
	dh_installdocs -i
	dh_installinfo -i
	dh_installexamples -i
	dh_installchangelogs
	dh_link --verbose -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## cl-asdf 2.24

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 ## MINOR FAIL: xcl (logical pathname issue in asdf-pathname-test.script)
 ## OCCASIONALLY TESTED BY NOT ME: allegromodern (not in my free demo version)
 ## MAJOR FAIL: gclcvs -- COMPILER BUG! Upstream fixed it, but upstream fails to compile.
-## NOT SUPPORTED BY OUR TESTS: cormancl genera rmcl. Manually tested once in a while.
+## NOT SUPPORTED BY OUR TESTS: cormancl genera mkcl rmcl. Manually tested once in a while.
 
 lisp ?= sbcl
 
@@ -22,6 +22,7 @@
 CLISP ?= clisp
 SBCL ?= sbcl
 ECL ?= ecl
+MKCL ?= mkcl
 CMUCL ?= cmucl
 ABCL ?= abcl
 SCL ?= scl
@@ -87,6 +88,7 @@
 	use_clisp () { li="${CLISP} -norc -ansi --quiet --quiet" ; ev="-x" ; } ; \
 	use_sbcl () { li="${SBCL} --noinform --no-userinit" ; ev="--eval" ; } ; \
 	use_ecl () { li="${ECL} -norc" ; ev="-eval" ; } ; \
+	use_mkcl () { li="${MKCL} -norc" ; ev="-eval" ; } ; \
 	use_cmucl () { li="${CMUCL} -noinit" ; ev="-eval" ; } ; \
 	use_abcl () { li="${ABCL} --noinit --nosystem --noinform" ; ev="--eval" ; } ; \
 	use_scl () { li="${SCL} -noinit" ; ev="-eval" ; } ; \
@@ -103,12 +105,16 @@
 	    echo "Testing upgrade from ASDF $${tag} using method $$x" ; \
 	    git show $${tag}:asdf.lisp > tmp/asdf-$${tag}.lisp ; \
 	    case ${lisp}:$$tag:$$x in \
-	      ecl:1.*|ecl:2.00*|ecl:2.01[0-6]:*|ecl:2.20:*) \
-		: Skip, because of various ASDF issues ;; \
+	      abcl:2.0[01][1-9]|abcl:2.2[1-2]:*) \
+		: Skip, because it is so damn slow ;; \
 	      ccl:1.*|ccl:2.0[01]*) \
 		: Skip, because ccl broke old asdf ;; \
 	      cmucl:1.*|cmucl:2.00*|cmucl:2.01[0-4]:*) \
 		: Skip, CMUCL has problems before 2.014.7 due to source-registry upgrade ;; \
+	      ecl:1.*|ecl:2.0[01]*|ecl:2.20:*) \
+		: Skip, because of various ASDF issues ;; \
+	      mkcl:1.*|mkcl:2.0[01]*|mkcl:2.2[0-3]:*) \
+		: Skip, because MKCL is only supported starting with 2.24 ;; \
 	      *) (set -x ; \
                   case $$x in \
 		    load-system) l="$$lo (asdf-test::load-asdf-system)" ;; \

=== debian/changelog ===
cl-asdf (2:2.24-1) unstable; urgency=low

  * ACL: handle SMP vs non-SMP builds in Allegro 9.0
  * MKCL: add support for ManKai Common Lisp
  * ECL: merge improvements from ECL git. Refactor ECL support somewhat.
  * Remove broken-fasl-support: first, cormanlisp is supposed to have fixed it;
    second, cormanlisp is dead;
    third, one can now (setf *load-system-operation* 'load-source-op) instead
    while using asdf:load-system.
  * renaming ends-with to string-suffix-p to avoid conflict with alexandria.
  * Refactor load-system to use *load-system-operation*,
    and change require-system and module-provide-asdf to use that.

  Also note:
  * We recommend you use asdf-utils to access the utilities in asdf.
    Some time next year, we may stop exporting the utilities from asdf itself.
  * To avoid conflicts between alexandria, fare-utils, xcvb-driver,
    asdf-utils, etc., you can use xcvb-utils that solves the conflicts.
    Or you can use fare-utils:define-package-mix that will help you
    automatically resolve them.

 -- Francois-Rene Rideau <fare@tunes.org>  Sat, 25 Aug 2012 08:05:21 -0400

cl-asdf (2:2.23-1) unstable; urgency=low

  * add new :compile-check argument to compile-file* and around-compile-hook.
    This allows for consistency check of .fasl output before the file can
    possibly be seen by other builds (i.e. no race condition).
  * export more utilities for dealing with pathnames from environment.

 -- Francois-Rene Rideau <fare@tunes.org>  Tue, 17 Jul 2012 11:03:32 -0400

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian Common Lisp Team <pkg-common-lisp-devel@lists.alioth.debian.org>
 Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
   Milan Zamazal <pdm@zamazal.org>,
+  Christoph Egger <christoph@debian.org>,
   Francois-Rene Rideau <fare@tunes.org>
 Build-Depends: debhelper (>> 7)
 Build-Depends-Indep: texinfo, texlive-extra-utils, texlive, texlive-generic-recommended
@@ -15,11 +16,13 @@
 Architecture: all
 Recommends: common-lisp-controller, sbcl | lisp-compiler
 Replaces: sbcl-common (<= 1:0.9.13.0-2)
-Conflicts: sbcl-common (<= 1:0.9.13.0-2), common-lisp-controller (<< 7.3)
-Breaks: common-lisp-controller (<< 7.3)
+Breaks: sbcl-common (<= 1:0.9.13.0-2), common-lisp-controller (<< 7.3)
 Depends: ${misc:Depends}
 Description: Another System Definition Facility
  asdf provides a "make" type functions for Common Lisp software.
  It drives compilation and dynamic loading for complex Lisp systems
  with multiple modules and files, and is the de facto standard used
  by free software written in Common Lisp.
+ .
+ Most Common Lisp implementations already provide asdf via (require "asdf"),
+ but not all of them provide an up-to-date version.

## cl-asdf 3.0.1.2

=== Makefile ===
system	 	:= "asdf"
webhome_private := common-lisp.net:/project/asdf/public_html/
webhome_public	:= "http://common-lisp.net/project/asdf/"
clnet_home      := "/project/asdf/public_html/"
sourceDirectory := $(shell pwd)

#### Common Lisp implementations available for testing.
## export ASDF_TEST_LISPS to override the default list of such implementations,
## or specify a lisps= argument at the make command-line
ifdef ASDF_TEST_LISPS
lisps ?= ${ASDF_TEST_LISPS}
else
lisps ?= ccl clisp sbcl ecl ecl_bytecodes cmucl abcl scl allegro lispworks allegromodern xcl gcl
endif
## NOT SUPPORTED BY OUR AUTOMATED TESTS:
##	cormancl genera lispworks-personal-edition mkcl rmcl
## Some are manually tested once in a while.
## MAJOR FAIL: gclcvs -- Compiler bug fixed upstream, but gcl fails to compile on modern Linuxen.
## grep for #+/#- features in the test/ directory to see plenty of disabled tests.
ifdef ASDF_TEST_SYSTEMS
s ?= ${ASDF_TEST_SYSTEMS}
endif

l ?= sbcl

ABCL ?= abcl
ALLEGRO ?= alisp
ALLEGROMODERN ?= mlisp
CCL ?= ccl
CLISP ?= clisp
CMUCL ?= cmucl
ECL ?= ecl
GCL ?= gcl
LISPWORKS ?= lispworks
MKCL ?= mkcl
SBCL ?= sbcl
SCL ?= scl
XCL ?= xcl

# website, tag, install

header_lisp := header.lisp
driver_lisp := uiop/package.lisp uiop/common-lisp.lisp uiop/utility.lisp uiop/os.lisp uiop/pathname.lisp uiop/filesystem.lisp uiop/stream.lisp uiop/image.lisp uiop/run-program.lisp uiop/lisp-build.lisp uiop/configuration.lisp uiop/backward-driver.lisp uiop/driver.lisp
defsystem_lisp := upgrade.lisp component.lisp system.lisp cache.lisp find-system.lisp find-component.lisp operation.lisp action.lisp lisp-action.lisp plan.lisp operate.lisp backward-internals.lisp defsystem.lisp bundle.lisp concatenate-source.lisp output-translations.lisp backward-interface.lisp source-registry.lisp interface.lisp user.lisp footer.lisp
all_lisp := $(header_lisp) $(driver_lisp) $(defsystem_lisp)

# Making ASDF itself should be our first, default, target:
build/asdf.lisp: $(all_lisp)
	mkdir -p build
	cat $(all_lisp) > $@

# This quickly locates such mistakes as unbalanced parentheses:
load: build/asdf.lisp
	./test/run-tests.sh -t $l $(all_lisp)

install: archive

bump: bump-version
bump-version: build/asdf.lisp
	./bin/asdf-builder bump-version ${v}

driver-files:
	@echo $(driver_lisp)

defsystem-files:
	@echo $(defsystem_lisp)

archive: build/asdf.lisp
	./bin/asdf-builder make-and-publish-archive

### Count lines separately for asdf-driver and asdf itself:
wc:
	@wc $(driver_lisp) | sort -n ; echo ; \
	wc $(header_lisp) $(defsystem_lisp) | sort -n ; \
	echo ; \
	wc $(header_lisp) $(driver_lisp) $(defsystem_lisp) | tail -n 1

push:
	git status
	git push --tags cl.net release master
	git push --tags github release master
	git fetch
	git status

doc:
	${MAKE} -C doc

website:
	${MAKE} -C doc website

clean_dirs = $(sourceDirectory)
clean_extensions = fasl dfsl cfsl fasl fas lib dx32fsl lx64fsl lx32fsl ufasl o bak x86f vbin amd64f sparcf sparc64f hpf hp64f

clean:
	@for dir in $(clean_dirs); do \
	     if test -d $$dir; then \
	     	 echo Cleaning $$dir; \
		 for ext in $(clean_extensions); do \
		     find $$dir \( -name "*.$$ext" \) \
	     	    -and -not -path \""*/.git/*"\" \
		     	  -and -not -path \""*/_darcs/*"\" \
	     		  -and -not -path \""*/tags/*"\" -print -delete; \
		done; \
	     fi; \
	done
	rm -rf build/ LICENSE test/try-reloading-dependency.asd test/hello-world-example
	rm -rf .pc/ build-stamp debian/patches/ debian/debhelper.log debian/cl-asdf/ # debian crap
	${MAKE} -C doc clean

mrproper:
	git clean -xfd

test-upgrade: build/asdf.lisp
	./test/run-tests.sh -u ${l}
u: test-upgrade

test-clean-load: build/asdf.lisp
	./test/run-tests.sh -c ${l}

# test-glob has been replaced by t, and lisp by l, easier to type
test-lisp: build/asdf.lisp
	@cd test; ${MAKE} clean;./run-tests.sh ${l} ${t}
t: test-lisp

test: test-lisp test-clean-load test-load-systems doc

test-load-systems: build/asdf.lisp
	./test/run-tests.sh -l ${l} ${s}

test-all-lisps:
	${MAKE} test-load-systems
	@for lisp in ${lisps} ; do \
		${MAKE} test-lisp test-upgrade test-clean-load l=$$lisp || exit 1 ; \
	done

# test upgrade is a very long run... This does just the regression tests
test-all-no-upgrade:
	@for lisp in ${lisps} ; do \
		${MAKE} test-lisp test-clean-load l=$$lisp || exit 1 ; \
	done

test-all-upgrade:
	@for lisp in ${lisps} ; do \
		${MAKE} test-upgrade l=$$lisp || exit 1 ; \
	done

test-all: doc test-all-lisps

test-all-no-stop:
	-make doc ; for l in ${lisps} ; do make t l=$$l ; make u l=$$l ; done ; true

extract-all-tagged-asdf: build/asdf.lisp
	./test/run-tests.sh -H

# Note that the debian git at git://git.debian.org/git/pkg-common-lisp/cl-asdf.git is stale,
# as we currently build directly from upstream at git://common-lisp.net/projects/asdf/asdf.git
debian-package: mrproper
	: $${RELEASE:="$$(git tag -l '3.[0-9].[0-9]' | tail -n 1)"} ; echo building package version $$RELEASE ; \
	git-buildpackage --git-debian-branch=release --git-upstream-branch=release --git-upstream-tag=$$RELEASE --git-tag --git-retag --git-ignore-branch

# Replace SBCL's ASDF with the current one. -- NOT recommended now that SBCL has ASDF2.
# for casual users, just use (asdf:load-system :asdf)
replace-sbcl-asdf: build/asdf.lisp
	${SBCL} --eval '(compile-file "$<" :output-file (format nil "~Aasdf/asdf.fasl" (sb-int:sbcl-homedir-pathname)))' --eval '(quit)'

# Replace CCL's ASDF with the current one. -- NOT recommended now that CCL has ASDF2.
# for casual users, just use (asdf:load-system :asdf)
replace-ccl-asdf: build/asdf.lisp
	${CCL} --eval '(progn(compile-file "$<" :output-file (compile-file-pathname (format nil "~Atools/asdf.lisp" (ccl::ccl-directory))))(quit))'

WRONGFUL_TAGS := 1.37 1.1720 README RELEASE STABLE # It's not 1.37, it's 1.85! 1.37 is for the README.
# Delete wrongful tags from local repository
fix-local-git-tags:
	for i in ${WRONGFUL_TAGS} ; do git tag -d $$i ; done

# Delete wrongful tags from remote repository
fix-remote-git-tags:
	for i in ${WRONGFUL_TAGS} ; do git push $${REMOTE:-cl.net} :refs/tags/$$i ; done

release-push:
	git checkout master
	git merge release
	git checkout release
	git merge master
	git checkout master

TODO:
	exit 2

release: TODO test-all test-on-other-machines-too debian-changelog debian-package send-mail-to-mailing-lists

.PHONY: install archive push doc website clean mrproper \
	test-forward-references test test-lisp test-upgrade test-forward-references \
	test-all test-all-lisps test-all-no-upgrade \
	debian-package release \
	replace-sbcl-asdf replace-ccl-asdf \
	fix-local-git-tags fix-remote-git-tags wc wc-driver wc-asdf

# RELEASE checklist:
# make test-all
# make test-load-systems s=fare-all
# make bump v=3.0
# edit debian/changelog
# make release-push archive website debian-package
# dput mentors ../*.changes
# send debian mentors request
# send announcement to asdf-announce, asdf-devel, etc.
#
## Users don't release as above, only maintainers do.
## Users, all you need to do is: make
## Vendors, you may want to test your implementation with: make test l=sbcl

=== debian/changelog ===
cl-asdf (2:3.0.1.2-1) unstable; urgency=low

  ASDF 3.0.1.2 fixes issues with the debian package itself.
  It also includes fixes to run-program and run-shell-command.

 -- Francois-Rene Rideau <fare@tunes.org>  Mon, 27 May 2013 22:44:50 -0400

cl-asdf (2:3.0.1-1) unstable; urgency=low

  ASDF 3.0.1 is an emergency release for better compatibility with Quicklisp.

  * version-satisfies now uses uiop:version<= for comparison,
    and does not check for a same major version number,
    like version-compatible-p does, which was the
    undocumented behavior since ASDF 1.

 -- Francois-Rene Rideau <fare@tunes.org>  Mon, 16 May 2013 19:20:28 -0400

cl-asdf (2:3.0.0-1) unstable; urgency=low

  ASDF 3.0.0 is the first official release of ASDF 3;
  ASDF 2.27 to 2.33 were pre-releases.
  Since 2.33, the following changes were done:

  * Portability: have *uninteresting-conditions* be empty by default.
    Move stuff to *usual-uninteresting-conditions*, unused by default.
    Will make the SBCL team happy. Also, fix tests on ABCL.
    Fix regression of program-op on ECL, by implicitly linking in UIOP or ASDF.

  * UIOP: improvements to slurp-input-stream and thus run-program,
    notably accepting T as alias for *standard-output*,
    for better backward-compatibility of the deprecated run-shell-command.
    New macro with-output-file.

  * POIU support enhanced with various tweaks.

  * Build cleanup so make and concatenate-source-op create the same asdf.lisp

 -- Francois-Rene Rideau <fare@tunes.org>  Mon, 15 May 2013 23:57:22 -0400

cl-asdf (2:2.33-1) unstable; urgency=low

  ASDF 2.33 is a set of cleanups since 2.32.
  Since previous release 2.32, it includes the following changes:

  * Portability tweaks for ABCL, Allegro, CCL, CLISP, ECL, LispWorks, SBCL.

  * deferred-warning received yet more improvements for CCL.

  * upgrade is made more robust in many cases, notably for ECL, SBCL,
    or when using UIOP with an old ASDF<=2.26.

  * Packages have been tweaked to pass more tests,
    notably wrt what symbols are exported.

  * Image lifecycle support is improved, thanks to deploying ASDF3 for QRes.
    More options for dump-image on CCL; handle reentrance in restore-image.

  * delete-directory-tree, delete-empty-directory, copy-file,
    directory-exists-p, file-exists-p were added to UIOP,
    also better strcat, with reduce/strcat, base-string-p, etc.

  * Recompilation avoided for things already done by defsystem-depends-on.

  * monolithic-fasl-op was fixed in cases when the main system has components.

  * fasl-op and monolithic-fasl-op now work on ABCL trunk and upcoming 1.2.0,
    and will eventually replace the ABCL-JAR contrib.

  * *uninteresting-conditions* was added as a common list of conditions
    shared between the compile-time and load-time muffled conditions.

 -- Francois-Rene Rideau <fare@tunes.org>  Thu, 04 Apr 2013 01:54:26 -0400

cl-asdf (2:2.32-1) unstable; urgency=low

  ASDF 2.31 is yet another bug fix release in preparation of an upcoming ASDF 3.
  Since previous release 2.31, it includes the following changes:

  * deferred-warning checks are now disabled by default,
    to enhance backward compatibility with ASDF 2.26 and earlier.
    In the future, we will enable them by default,
    but not until we implement a smoother transition plan.

  * UIOP is the new official name for ASDF-DRIVER.
    "Utilities for Implementation- and OS- Portability".
    Old names remain as package and system nicknames:
    . ASDF/DRIVER ASDF-DRIVER ASDF-UTILS

  * require-system so systems may depend on implementation-provided modules.

  * auto-upgrade attempt in operate *before* the implicit find-system.

  * class specification for components can now be a string to be read as a symbol.

  * feature conditional dependencies are now debugged and tested:
    . :depends-on ("some-system" (:feature :foo "other-system))
    we only recommend them for dependencies between systems;
    within systems, we recommend you use feature-conditional components with
    . :if-feature :foo
    and we only provide limited support for the deprecated legacy way of using
    feature-conditionals with a module having :if-component-dep-fails :ignore
    while its components specify things like:
    . :in-order-to ((compile-op (feature :foo)))

  * read-from-file for :version specification is made more useful by using
    the ASDF-USER package rather than CL (into which interning is forbidden)
    to read the files.

 -- Francois-Rene Rideau <fare@tunes.org>  Tue, 05 Mar 2013 19:35:43 -0500

cl-asdf (2:2.31-1) unstable; urgency=low

  ASDF 2.31 is another bug fix release in preparation of an upcoming ASDF 3.
  Since previous release 2.30, it includes the following changes:

  * *default-encoding* is now UTF-8. As tested with cl-test-grid,
    This is a boon for most programs,
    that will compile in a more predictable way in a wider range of settings.
    A handful of unmaintained outliers still need to be fixed.

  * Downgrade is now explicitly avoided. ASDF will issue a warning
    if your system is misconfigured in a way that specifies downgrade,
    but will then ignore the specified ASDF downgrade.

  * version specifications, when invalid, will lead only to a warning for now;
    a future ASDF3 may restore the behavior of ASDF 2.27,
    that raises an errors when there is a bad :version specification,
    but for now, backward compatibility prevails.

  * ECL support received several bug fixes.

  * precompiled-system support was notably fixed, enabling single-fasl
    deployment of SBCL contribs.

 -- Francois-Rene Rideau <fare@tunes.org>  Mon, 25 Feb 2013 19:02:14 -0500

cl-asdf (2:2.30-1) unstable; urgency=low

  ASDF 2.30 is another bug fix release in preparation of an upcoming ASDF 3.
  Since previous release 2.29, it includes:

  * syntax around loading .asd files made more backward-compatible,
    by *not* (for now) binding *readtable* and *print-pprint-dispatch*


=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,4 @@
 #!/usr/bin/make -f
-# MAde with the aid of dh_make, by Craig Small
-# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
-# Some lines taken from debmake, by Cristoph Lameter.
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -9,6 +6,7 @@
 build: build-stamp
 build-stamp:
 	dh_testdir
+	make
 	make -C doc all
 	touch build-stamp

## cl-asdf 3.0.1.3

=== Makefile ===
--- 
+++ 
@@ -103,7 +103,7 @@
 		done; \
 	     fi; \
 	done
-	rm -rf build/ LICENSE test/try-reloading-dependency.asd test/hello-world-example
+	rm -rf build/ LICENSE test/try-reloading-dependency.asd test/hello-world-example asdf.lisp
 	rm -rf .pc/ build-stamp debian/patches/ debian/debhelper.log debian/cl-asdf/ # debian crap
 	${MAKE} -C doc clean

## cl-asdf 3.0.2.4

=== Makefile ===
--- 
+++ 
@@ -21,6 +21,10 @@
 s ?= ${ASDF_TEST_SYSTEMS}
 endif
 
+ifdef ASDF_DEVEL_SOURCE_REGISTRY
+export CL_SOURCE_REGISTRY = ${ASDF_DEVEL_SOURCE_REGISTRY}
+endif
+
 l ?= sbcl
 
 ABCL ?= abcl
@@ -119,7 +123,7 @@
 
 # test-glob has been replaced by t, and lisp by l, easier to type
 test-lisp: build/asdf.lisp
-	@cd test; ${MAKE} clean;./run-tests.sh ${l} ${t}
+	@cd test; ./run-tests.sh ${l} ${t}
 t: test-lisp
 
 test: test-lisp test-clean-load test-load-systems doc
@@ -149,6 +153,7 @@
 test-all-no-stop:
 	-make doc ; for l in ${lisps} ; do make t l=$$l ; make u l=$$l ; done ; true
 
+extract: extract-all-tagged-asdf
 extract-all-tagged-asdf: build/asdf.lisp
 	./test/run-tests.sh -H
 
@@ -157,6 +162,11 @@
 debian-package: mrproper
 	: $${RELEASE:="$$(git tag -l '3.[0-9].[0-9]' | tail -n 1)"} ; echo building package version $$RELEASE ; \
 	git-buildpackage --git-debian-branch=release --git-upstream-branch=release --git-upstream-tag=$$RELEASE --git-tag --git-retag --git-ignore-branch
+
+debian-package-from-master: mrproper
+	: $${RELEASE:="$$(git tag -l '3.[0-9].[0-9]' | tail -n 1)"} ; echo building package version $$RELEASE ; \
+	git-buildpackage --git-debian-branch=master --git-upstream-branch=master --git-upstream-tag=$$RELEASE --git-tag --git-retag --git-ignore-branch
+
 
 # Replace SBCL's ASDF with the current one. -- NOT recommended now that SBCL has ASDF2.
 # for casual users, just use (asdf:load-system :asdf)
@@ -201,6 +211,9 @@
 # make test-load-systems s=fare-all
 # make bump v=3.0
 # edit debian/changelog
+# git commit
+# git tag 3.0 # for example ...
+# make debian-package
 # make release-push archive website debian-package
 # dput mentors ../*.changes
 # send debian mentors request

## cl-asdf 3.0.3

=== Makefile ===
--- 
+++ 
@@ -206,13 +206,16 @@
 	replace-sbcl-asdf replace-ccl-asdf \
 	fix-local-git-tags fix-remote-git-tags wc wc-driver wc-asdf
 
-# RELEASE checklist:
+# RELEASE or PUSH checklist:
 # make test-all
 # make test-load-systems s=fare-all
 # make bump v=3.0
-# edit debian/changelog
+# edit debian/changelog # RELEASE only...
 # git commit
 # git tag 3.0 # for example ...
+# git push
+# git push origin 3.0 # for example...
+# everything from here for RELEASE only
 # make debian-package
 # make release-push archive website debian-package
 # dput mentors ../*.changes

=== doc/Makefile ===
#user=frideau
ifeq (${user},)
userat :=
else
userat := ${user}@
endif
website:=${userat}common-lisp.net:/project/asdf/public_html/
output = asdf.html asdf asdf.pdf asdf.info
webfiles = index.html .htaccess style.css cclan.png lisp-logo120x80.png favicon.ico ${output}
intermediate = asdf.cps asdf.log asdf.vr asdf.aux asdf.fn asdf.toc asdf.vrs \
	asdf.cp asdf.fns asdf.ky asdf.pg asdf.tp

all:	asdf.html asdf.info asdf.pdf manual-html

manual-html: asdf.texinfo
	makeinfo --html asdf.texinfo

asdf.html: asdf.texinfo
	makeinfo --html --no-split --no-headers -o asdf.html asdf.texinfo

asdf.info: asdf.texinfo
	makeinfo asdf.texinfo

asdf.pdf: asdf.texinfo
	texi2pdf asdf.texinfo

website: all
	rsync -av ${webfiles} ${website}

.PHONY: clean veryclean manual-html
clean:
	rm -f ${intermediate}
veryclean: clean
	rm -f asdf.html asdf.pdf asdf.info
	rm -rf asdf/ asdf.t2d/

## cl-asdf 3.1.4

=== Makefile ===
# -*- Makefile -*- This minimal Makefile delegates most work to the asdf-tools script
#
# End-Users, all you need to do is:
#   make
#
# Vendors, you may want to test your implementation with:
#   make test l=sbcl
# BUT you first need have installed the development-time external dependencies of ASDF,
# which will be done automatically if you are using quicklisp,
# which you can do manually with your favorite tools (e.g. clbuild or git), or
# which you can do using `git submodule update` which is also available as:
#   make ext
#
# Other targets are for maintainer use only.
#

l ?= sbcl

# Default action: bootstrap asdf.lisp
# That's the only thing that we really need before we may invoke asdf-builder.
all: build/asdf.lisp
	@: # This dummy action is necessary so the all target does not invoke the fallback action.

# Download all the development-time dependencies of ASDF:
ext:
	git submodule update --init

# Remove all the development-time dependencies of ASDF:
noext:
	for i in $$(git submodule foreach 'echo $$path') ; do git submodule deinit $$i ; done

header_lisp := header.lisp
driver_lisp := uiop/package.lisp uiop/common-lisp.lisp uiop/utility.lisp uiop/os.lisp uiop/pathname.lisp uiop/filesystem.lisp uiop/stream.lisp uiop/image.lisp uiop/run-program.lisp uiop/lisp-build.lisp uiop/configuration.lisp uiop/backward-driver.lisp uiop/driver.lisp
defsystem_lisp := upgrade.lisp component.lisp system.lisp cache.lisp find-system.lisp find-component.lisp operation.lisp action.lisp lisp-action.lisp plan.lisp operate.lisp output-translations.lisp source-registry.lisp backward-internals.lisp parse-defsystem.lisp bundle.lisp concatenate-source.lisp backward-interface.lisp package-inferred-system.lisp interface.lisp user.lisp footer.lisp

# Making ASDF itself should be our first, default, target:
build/asdf.lisp: $(header_lisp) $(driver_lisp) $(defsystem_lisp)
	mkdir -p build
	rm -f $@
	cat $^ > $@

# These targets are used during tests to ensure the Makefile is in synch with the .asd files.
driver-files:
	@echo $(driver_lisp)

defsystem-files:
	@echo $(defsystem_lisp)

### exclude source files from fallback rule.
%.lisp:
	@:
Makefile:
	@:

### Default fall back rule: delegate to asdf-tools.
# Note that the l= L= etc. are the only way I (Faré) have found to
# pass arguments from the Makefile to the underlying script:
# l= overrides $ASDF_TEST_LISPS to specify which lisp implementations to use
# L= overrides $ASDF_UPGRADE_TEST_LISPS (defaults to the former) to lisps during upgrade
# s= overrides $ASDF_TEST_SYSTEMS to specify systems with which to test ASDF
# t= overrides $ASDF_TESTS to specify test script patterns to use (default to *.script)
# u= overrides $ASDF_UPGRADE_TEST_TAGS to specify versions to upgrade from (e.g. 3.0.3 or REQUIRE)
# U= overrides $ASDF_UPGRADE_TEST_METHODS to specify upgrade methods
# v= overrides the default next version for bump-version or bump.
# see in tools/test-environment.lisp for details.
# Note that because of how make and the shell quote arguments,
# thou shalt not use the single-quote character in any of the short x= parameters
# (but you may use them in the long variant in the exported environment variable).
# To have a list of commands, see make help or ./tools/asdf-tools help
# Note that when you call ./tools/asdf-tools directly,
# you may have to use positional parameters instead (unless you use env as below), as in
#   ./tools/asdf-tools bump 3.2.1
# instead of
#   make bump v=3.2.1
# or
#   ./tools/asdf-tools env v=3.2.1 bump
# or
#   v=3.2.1 ./tools/asdf-tools bump
%: build/asdf.lisp
	./tools/asdf-tools env l='$l' L='$L' u='$u' U='$u' v='$v' s='$s' t='$t' $@

# This is the list of phony targets from this file
.PHONY: all driver-files defsystem-files ext force

# The text below was automaticaly generated by `make --silent makefile-targets`
# then manually inserted here to provide for completion:
archive build-asdf bump bump-version check-all-results check-all-scripts-results check-all-upgrade-results clean debian-package doc extract extract-all-tagged-asdf extract-tagged-asdf fix-local-git-tags fix-remote-git-tags git-all-committed-p help install install-asdf link-archive load make-and-publish-archive make-archive makefile-targets merge-master-into-release publish-archive publish-debian-package push re show-commands t test test-all test-all-clean-load test-all-no-stop test-all-no-upgrade test-all-no-upgrade-no-stop test-all-scripts test-all-scripts-no-stop test-all-upgrade test-all-upgrade-no-stop test-basic test-clean-load test-load-systems test-scripts test-upgrade u wc website: force
        ./tools/asdf-tools env l='$l' L='$L' u='$u' U='$u' v='$v' s='$s' t='$t' $@

=== doc/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 output = asdf.html asdf asdf.pdf asdf.info
 webfiles = index.html .htaccess style.css cclan.png lisp-logo120x80.png favicon.ico ${output}
 intermediate = asdf.cps asdf.log asdf.vr asdf.aux asdf.fn asdf.toc asdf.vrs \
-	asdf.cp asdf.fns asdf.ky asdf.pg asdf.tp
+		asdf.cp asdf.fns asdf.ky asdf.pg asdf.tp asdf.tps
 
 all:	asdf.html asdf.info asdf.pdf manual-html
 
@@ -26,6 +26,7 @@
 
 website: all
 	rsync -av ${webfiles} ${website}
+	rsync -av ../debian/changelog ${website}/changelog
 
 .PHONY: clean veryclean manual-html
 clean:

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,7 @@
 	dh_testdir
 	make
 	make -C doc all
+	ln -sf build/asdf.lisp .
 	touch build-stamp
 
 build-arch:
@@ -29,7 +30,6 @@
 	dh_testdir -i
 	dh_testroot -i
 	dh_prep -i
-	chmod +x test/run-tests.sh
 	dh_installdirs -i
 	dh_install -i
 	#dh_lisp -i

## cl-asdf 3.1.5

=== doc/Makefile ===
#user=frideau
ifeq (${user},)
userat :=
else
userat := ${user}@
endif
website:=${userat}common-lisp.net:/project/asdf/public_html/
output = asdf.html asdf asdf.pdf asdf.info
webfiles = index.html .htaccess style.css cclan.png lisp-logo120x80.png favicon.ico ${output}
intermediate = asdf.cps asdf.log asdf.vr asdf.aux asdf.fn asdf.toc asdf.vrs \
		asdf.cp asdf.fns asdf.ky asdf.pg asdf.tp asdf.tps

all:	asdf.html asdf.info asdf.pdf manual-html

version.texinfo: ../version.lisp-expr
	head -n 1 $^ | perl -ne 'm|\"(.*)\"|; print "\@set VERSION $$1\n"' > $@

manual-html: asdf.texinfo version.texinfo
	makeinfo --html asdf.texinfo \
	2>&1 > manual-html.log || { echo "failed. See log in manual-html.log" ; exit 1 ;}

asdf.html: asdf.texinfo version.texinfo
	makeinfo --html --no-split --no-headers -o asdf.html asdf.texinfo \
	2>&1 > asdf.html.log || { echo "failed. See log in asdf.html.log" ; exit 1 ;}

asdf.info: asdf.texinfo version.texinfo
	makeinfo asdf.texinfo

asdf.pdf: asdf.texinfo version.texinfo
	texi2pdf asdf.texinfo \
	2>&1 > asdf.pdf.log || { echo "failed. See log in asdf.pdf.log" ; exit 1 ;}

website: all
	rsync -lt --no-g ${webfiles} ${website}
	rsync --recursive --no-g --delete asdf ${website}
	rsync -lt --no-g ../debian/changelog ${website}/changelog

.PHONY: clean intermediate-clean manual-html
intermediate-clean:
	rm -f ${intermediate}
clean: intermediate-clean
	rm -f asdf.html asdf.pdf asdf.info
	rm -rf asdf/ asdf.t2d/
